# Paginator-JS
[![version](https://img.shields.io/npm/v/@carry0987/paginator.svg)](https://www.npmjs.com/package/@carry0987/paginator) ![CI](https://github.com/carry0987/Paginator-JS/actions/workflows/ci.yml/badge.svg)  

**A pagination library that works everywhere**
- Simple and lightweight implementation
- No vendor lock-in. Pagination.js can be used with any JavaScript frameworks (React, Angular, Preact or VanillaJS)
- Written in TypeScript
- Supports all modern browsers

## Example
```js
new Paginator({
  data: [
    ['Mike', 33, 'mike@murphy.com'],
    ['John', 82, 'john@conway.com'],
    ['Sara', 26, 'sara@keegan.com']
  ],
  columns: ['Name', 'Age', 'Email']
}).render(document.getElementById('wrapper'));
```

Piece of :cake:

## Getting Started
- [Install](https://carry0987.github.io/Paginator-JS/docs/install)
- [Getting Started](https://carry0987.github.io/Paginator-JS/docs/)
- [Examples](https://carry0987.github.io/Paginator-JS/docs/examples/hello-world)

## Documentation :book:
Full documentation of Paginator.js installation, config, API and examples are available
on Paginator.js website [Paginator.js](https://carry0987.github.io/Paginator-JS/). 
